---
title: XRSession.visibilityState
slug: Web/API/XRSession/visibilityState
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Property
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XRSession
  - visibilityState
---
<div>{{securecontext_header}}{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">The <em>read-only</em> <strong><code>visibilityState</code></strong> property of the {{DOMxRef("XRSession")}} interface is a string indicating whether the WebXR content is currently visible to the user, and if it is, whether it's the primary focus.</span></p>

<p>Every time the visibility state changes, a {{DOMxRef("XRSession.visibilitychange_event","visibilitychange")}} event is fired on the {{DOMxRef("XRSession")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>visibilityState</em> = <em>xrSession</em>.visibilityState;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} containing one of the values defined in the enumerated type {{domxref("XRVisibilityState")}}; this string indicates whether or not the XR content is visible to the user and if it is, whether or not it's currently the primary focus.</p>

<p>The possible values of <code>visibilityState</code> are:</p>

<p>{{page("/en-US/docs/Web/API/XRVisibilityState", "Values")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>It's important to keep in mind that because an immersive WebXR session is potentially being shown using a different display than the HTML document in which it's running (such as when being shown on a headset), the value of a session's <code>visibilityState</code> may not necessarily be the same as the owning <em>{{domxref("document")}}'s</em> {{domxref("Document.visibilityState", "visibilityState")}}. For instance, if the viewer is using a headset tethered to a computer and the immersive scene is obscured by a configuration UI, the user could peek out from behind the headset and still be able to see the document itself on their computer's monitor.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-visibilitystate","XRSession.visibilityState")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.visibilityState")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("XRSession.onvisibilitychange")}}</li>
 <li>{{DOMxRef("XRSession.visibilitychange_event","visibilitychange")}} event</li>
</ul>
